import mysql.simplesql as sql

tables = ['client']


def getOptionsValue(options):
    optionsValue = 0
    if options.get("sendchecktoemail", 0) == 1:
        optionsValue |= 1
    if options.get("emailconfirmed", 0) == 1:
        optionsValue |= 2
    return optionsValue


def getCommunicationsValue(options):
    optionsValue = 0
    optionsValue |= 1 if options.get('call', 0) else 0
    optionsValue |= 2 if options.get('telegram', 0) else 0
    optionsValue |= 4 if options.get('email', 0) else 0
    optionsValue |= 8 if options.get('sms', 0) else 0
    return optionsValue


def insertClient(client):
    yield sql.Insert(table='client', values={
        'idclient': client.get('idclient', None),
        'name': client.get('name', None),
        'text': client.get('text', None),
        'sex': client.get('sex', None),
        'birthday': client.get('birthday', None) if client.get('birthday', None) else None,
        'specialdate1': client.get('specialdate1', None) if client.get('specialdate1', None) else None,
        'specialdate2': client.get('specialdate2', None) if client.get('specialdate2', None) else None,
        'specialdate3': client.get('specialdate3', None) if client.get('specialdate3', None) else None,
        'specialdate1name': client.get('specialdate1name', None),
        'specialdate2name': client.get('specialdate2name', None),
        'specialdate3name': client.get('specialdate3name', None),
        'zipcode': client.get('zipcode', None),
        'address': client.get('address', None),
        'email': client.get('email', None),
        'webpage': client.get('webpage', None),
        'phonenumber': client.get('phonenumber', None),
        'inn': client.get('inn', None),
        'document': client.get('document', None),
        'okpo': client.get('okpo', None),
        'okpd': client.get('okpd', None),
        'occupation': client.get('occupation', None),
        'childrencount': client.get('childrencount', None),
        'extendedoptions': client.get('extendedoptions', None),
        'organizationcode': client.get('organizationcode', None),
        'subscriptionadj': client.get('subscriptionadj', None),
        'options': getOptionsValue(client.get('options', {})),
        'lastname': client.get('lastname', None),
        'patronymic': client.get('patronymic', None),
        'communications': getCommunicationsValue(client.get('communications', {}))
    })


def deleteClient(client):
    for i in deleteClientById(client.get('idclient', None)):
        yield i    


def deleteClientById(id):
    yield sql.Delete(table='client', whereFields=['idclient'], whereValues=[id])


def update(client, byField):
    clientFields = list(client)
    clientFields.remove(byField)
    clientValues = []
    for field in clientFields:
        clientValues.append(client.get(field, None))
    return sql.Update(table='client', fields=clientFields, values=clientValues,
            whereField=byField, whereValue=[client.get(byField, None)])


def updateClient(client):
    if client.get('idclient', None) is not None:
        yield update(client, 'idclient')


def clearClient():
    yield sql.DeleteAll(table='client')
